/*
 * Copyright (c) 1983 Eric P. Allman
 * Copyright (c) 1988 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
**  3B1.H -- configurable parameters for sendmail on AT&T 3B1 platforms
**	with WIN/3B TCP/IP.
*/

/* VMUNIX for WIN/3B */
#define VMUNIX		1	/* running on systems w. 4.2/4.3 networking */

/* NEED_VSPRINTF needed if linking with the shared library */
#define NEED_VSPRINTF	1	/* Need the vsprintf() call */
#define	INTSPRINTF	1	/* used in vprintf.c */
#define	LONGINT		1	/* used in vprintf.c */

#define SYSV		1	/* running on a system 5 system */
#define SIG_TYPE	int	/* Value returned by signal() */
#define TIME_TYPE	time_t	/* Value used and returned by time() */
#define FCNTL_FLOCK	1	/* Berkeley flock() emulation using fcntl() */
#define LACK_WAIT3	1	/* wait3() is missing.  Fake w. wait() */
#define NEED_UNSETENV	1	/* Need the unsetenv() call */

#define	SYSTEM5		1	/* used in some system header files */
#define LIBC_SCCS 	1	/* include sccs id's in header files */

#ifdef __GNUC__
# ifdef __STRICT_ANSI__
#  define unixpc	1
#  define unix		1
#  define mc68k		1
# endif /* __STRICT_ANSI__ */
#else /* !__GNUC__ */
# define unixpc		1
#endif /* __GNUC__ */
