/*
 * Copyright (c) 1983 Eric P. Allman
 * Copyright (c) 1988 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
**  proto.H -- configurable parameters for sendmail on proto platforms.
*/

#define VMUNIX		1	/* running on systems w. 4.2/4.3 networking */
#define ISC		1	/* Interactive Unix Host-based TCP/IP */

/*
 * Pick one of the next three if your system lacks the flock() call.  Else
 * leave them all commented out.  They're used in deliver.c -- see also
 * support/flock.[ch]
 */
#define FCNTL_FLOCK	1	/* Berkeley flock() emulation using fcntl() */
#define LOCKF_FLOCK	1	/* Berkeley flock() emulation using lockf() */
#define USG_FLOCK	1	/* Berkeley flock() emulation w. lockfile() */

#define SIG_TYPE	void	/* Value returned by signal() */
#define TIME_TYPE	time_t	/* Value used and returned by time() */
#define SHARE		1	/* Convex share scheduler */
#define SYSV		1	/* running on a system 5 system */

/*
 * Routines that provide greater functionality.  Not required for normal
 * operation.
 */
/*#define HAS_UNAME	1	/* System has the uname() call */

/*
 * Missing routines.  Delete the leading comment character for any missing
 * routines.
 */
/*#define NEED_GETENV	1	/* Need the getenv() call */
/*#define NEED_SETENV	1	/* Need the setenv() call */
/*#define NEED_UNSETENV	1	/* Need the unsetenv() call */
/*#define NEED_VSPRINTF	1	/* Need the vsprintf() call */
/*#define LACK_WAIT3	1	/* wait3() is missing.  Fake w. wait() */
/*#define LACK_SIGBLOCK	1	/* sigblock() is missing.  Use sigprocmask() */
/*#define LACK_RENAME	1	/* rename() is missing.  Use link()/unlink() */
