/*
**  3B1.H -- declarations for sendmail on AT&T 3B1 platforms
**	with WIN/3B TCP/IP.
*/

#ifdef __GNUC__
/* declarations for these will speed gcc processing and reduce memory requirements */

# ifdef __STDC__
/*	system calls and pseudo-sytem calls */
extern	void	_exit(int);
extern	unsigned	alarm(unsigned int);
extern	int	chdir(char *);
extern	int	chmod(char *, int);
extern	int	close(int);
extern	int	creat(char *, int);
extern	int	dup(int);
extern	int	execve(char *, char **, char **);
extern	int	fcntl(int, int, ...);
extern	int	flock(int, int);
extern	int	fork();
extern	int	fstat(int, struct stat *);
extern	int	getegid();
extern	int	geteuid();
extern	int	getgid();
extern	int	getpid();
extern	int	getuid();
extern	int	kill(int, int);
extern	int	link(char *, char *);
extern	off_t	lseek(int, long, int);
extern	int	open(char *, int, ...);	
extern	int	pause();
extern	int	pipe(int *);
extern	int	read(int, char *, unsigned int);
extern	int	setgid(int);
extern	int	setpgrp();
extern	int	setuid(int);
/* ANSI declarations look like they were designed by a committee ... */
extern	SIG_TYPE	(*signal(int, SIG_TYPE (*func)(int))) (int);
extern	int	stat(const char *, struct stat *);
extern	int	umask(int);
extern	int	uname();
extern	int	unlink(char *);
extern	int	wait(int *);
extern	int	write(int, char *, unsigned int);

/*	C library functions and/or substitutes */
extern	struct	passwd	*getpwent();
extern	struct	passwd	*getpwnam(char *);
extern	struct	passwd	*getpwuid(int);
extern	void	longjmp(jmp_buf, int);
extern	char	*memcpy(void *, void *, size_t);
extern	char	*memset(void *, int, size_t);
extern	int	setjmp(jmp_buf);
extern	int	setpwent();
extern	int	tolower(int);
extern	int	toupper(int);
extern	char	*ttyname(int);

extern	int	strcasecmp(const char *, const char *);
extern	char	*strerror(int);
extern	int	strncasecmp(const char *, const char *, int);
extern	void	unsetenv(char *);

/* needed if LOG defined */
extern	void	openlog(char *, int, int);
extern	void	syslog(int, char *, ...);

/*	standard I/O library functions	*/
extern	int	_filbuf(FILE *);
extern	int	_flsbuf(int, FILE *);
extern	int	fclose(FILE *);
extern	int	fflush(FILE *);
extern	FILE	*fopen(const char *, const char *);
extern	int	fprintf(FILE *, const char *, ...);
extern	int	fputs(const char *, FILE *);
extern	int	fscanf(FILE *, const char *, ...);
extern	int	pclose(FILE *);
extern	int	printf(const char *, ...);
extern	int	sprintf(char *, const char *, ...);
extern	int	sscanf(const char *, const char *, ...);
extern	int	ungetc(int, FILE *);
extern	int	vsprintf(char *, const char *, va_list);

#  ifdef VMUNIX
/*	networking library functions	*/
extern	int	accept(int, struct sockaddr *, int *);
extern	int	bind(int, struct sockaddr *, int);
extern	int	connect(int, struct sockaddr *, int);
extern	struct hostent	*gethostbyname(const char *);
extern	int	gethostname(char *, int);
extern	struct servent	*getservbyname(char *, char *);
extern	unsigned long	inet_addr(const char *);
extern	char	*inet_ntoa(struct in_addr);
extern	int	listen(int, int);
extern	int	send(int, char *, int, int);
extern	int	setsockopt(int, int, int, char *, int);
extern	int	socket(int, int, int);
#  endif /* VMUNIX */
# endif /* __STDC__ */
#endif /* __GNUC__ */
